##################### Aula 05 #######################
# Introduo  Anlise de Redes                     #
# Gilvan R. Guedes e Wesley H. S. Pereira           #
#####################################################

######### Preparando os dados para o Gephi ##########

# Lendo o banco de dados

if(!require(xlsx)){install.packages("xlsx");
                  library(xlsx)}

data = read.xlsx(file="network_cedeplar_iussp2017.xlsx",
                 sheetIndex=3)
View(data)
str(data)

data1=data
for (i in c(1,2)){
  data1[,i]=as.character(data1[,i])
}

data1$Source.1=as.character(data1$Source.1)
data1$Target.1=as.character(data1$Target.1)

str(data)
str(data1)

# Autores

autor = data1[,c("Source","Target","Type","Weight",
                "Weight2","Paper")]
autor$Type=as.character(autor$Type)
str(autor)

# Instituies

inst = data1[,c("Source.1","Target.1","Type","Weight",
                "Weight2","Paper")]
colnames(inst) = colnames(autor)
names(inst)
inst$Type=as.character(inst$Type)

# Guedes

gp = unique(data$Paper[
  which(data$Source %in% "Guedes" | data$Target %in% "Guedes")])
gp
guedes = subset(autor, Paper %in% gp)


# Queiroz 

qp = unique(data$Paper[
  which(data$Source %in% "Queiroz" | data$Target %in% "Queiroz")])


queiroz = subset(autor, Paper %in% qp)


# Exportando bancos de dados para .csv

write.csv(autor,"autor.csv",row.names = F)
write.csv(inst,"inst.csv",row.names = F)
write.csv(guedes,"guedes.csv",row.names = F)
write.csv(queiroz,"queiroz.csv",row.names = F)

rm(data)

############# Analisando dados no R #################

f = function(m)
{
  for(i in 1:ncol(m))
  {
    for(j in 1:nrow(m))
    {
      m[i,j] = ifelse(m[i,j] == 0,0,1)
    }
  }
  return(m)
}

##### Tomando subconjuntos de dados

# Autores - direcionados

daut = subset(autor,Type == "directed")

# Autores - no-direcionados

uaut = subset(autor,Type == "undirected")

# Instituies - direcionados

dinst = subset(inst,Type == "directed")

# Instituies - no-direcionados

uinst = subset(inst,Type == "undirected")

# Guedes - direcionados

dg = subset(guedes,Type == "directed")

# Guedes - no-direcionados

ug = subset(guedes,Type == "undirected")

# Queiroz - direcionados

dq = subset(queiroz,Type == "directed")

# Queiroz - no-direcionados

uq = subset(queiroz,Type == "undirected")

##### Tomando matrizes de adjacncias

if(!require(igraph)){install.packages("igraph");
                    library(igraph)}

mda = as.matrix(get.adjacency(
      graph_from_data_frame(daut,T)))
mua = as.matrix(get.adjacency(
      graph_from_data_frame(uaut,F)))
mdi = as.matrix(get.adjacency(
      graph_from_data_frame(dinst,T)))
mui = as.matrix(get.adjacency(
      graph_from_data_frame(uinst,F)))
mdg = as.matrix(get.adjacency(
      graph_from_data_frame(dg,F)))
mug = as.matrix(get.adjacency(
      graph_from_data_frame(ug,F)))
mdq = as.matrix(get.adjacency(
      graph_from_data_frame(dq,F)))
muq = as.matrix(get.adjacency(
      graph_from_data_frame(uq,F)))

##### Tomando estatsticas descritivas da rede

if(!require(qgraph)){install.packages("qgraph");
                    library(qgraph)}

qaut = qgraphMixed(mua,mda)
qinst = qgraphMixed(mui,mdi)
qg =  qgraphMixed(mug,mdg)
qq =  qgraphMixed(muq,mdq)

centrality(qaut,pkg="qgraph")
centrality(qinst,pkg="qgraph")
centrality(qg,pkg="qgraph")
centrality(qq,pkg="qgraph")

##### Visualizao

if(!require(ggm)){install.packages("ggm");
  library(ggm)}

# Removendo pesos da matriz (o pacote ggm aparentemente 
# no suporta matrizes ponderadas) 

mda2 = f(mda)
mua2 = f(mua)
mdi2 = f(mdi)
mui2 = f(mui)
mdg2 = f(mdg)
mug2 = f(mug)
mdq2 = f(mdq)
muq2 = f(muq)


# Matriz mista

maut = makeMG(mda2,mua2)
minst = makeMG(mdi2,mui2)
mg = makeMG(mdg2,mug2)
mq = makeMG(mdq2,muq2)

# Visualizao

plotGraph(maut)
plotGraph(minst)
plotGraph(mg)
plotGraph(mq)
